#pragma once
#include <cstdio>
#include <fstream>
#include <windows.h>
#include <mutex>

#define TRACE(...) { Log::trace(__VA_ARGS__); }

class Log
{
	static FILE* m_logFile;
	static char *fileName[16];
public:
	Log(void)
	{
		*fileName = "test.log";
	}

	~Log(void)
	{
		fclose(m_logFile);
	}

	static void trace(char *message, ...)
	{	
		SYSTEMTIME	time;
		static char buffer[0x400];
		static std::mutex mut;
		std::lock_guard<std::mutex> lock(mut);
		GetLocalTime (&time);
		sprintf(buffer, "%02d/%02d/%04d %02d:%02d:%02d.%03d ", time.wDay, 
		time.wMonth, time.wYear, time.wHour, time.wMinute, time.wSecond, time.wMilliseconds);
		m_logFile = fopen(*fileName, "wt");
		va_list	arg;	
		va_start (arg, message);
		vsprintf (buffer + strlen(buffer), message, arg);
		va_end (arg);
		fprintf(m_logFile, buffer, "/n");
		OutputDebugString(buffer);
		OutputDebugString("\n");
	}

	static void Error(char *message)
	{
		MessageBox(nullptr, message, "CLEO error", MB_ICONERROR | MB_OK);
		TRACE("[Error] Exiting with error: %s", message);
		exit(1);
	}

	static void Warning(char *message)
	{
		MessageBox(nullptr, message, "CLEO warning", MB_ICONWARNING | MB_OK);
		TRACE("[Warning] %s", message);
		exit(1);
	}
};